VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   Caption         =   "Pseudo Non-overlapping Rectangles"
   ClientHeight    =   6165
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8400
   LinkTopic       =   "Form1"
   ScaleHeight     =   411
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   560
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   2280
      Top             =   2640
   End
   Begin VB.Frame Frame1 
      Height          =   1965
      Left            =   0
      TabIndex        =   0
      Top             =   -30
      Width           =   1455
      Begin VB.CommandButton cmdDrawSquares 
         Caption         =   "drawsquares"
         Height          =   375
         Left            =   120
         TabIndex        =   7
         Top             =   1500
         Width           =   1215
      End
      Begin VB.CommandButton cmdtimer1 
         Caption         =   "timer=off"
         Height          =   375
         Left            =   120
         TabIndex        =   6
         Top             =   120
         Width           =   1215
      End
      Begin VB.HScrollBar HScroll2 
         Height          =   255
         Left            =   120
         Max             =   1000
         Min             =   20
         TabIndex        =   4
         Top             =   1200
         Value           =   100
         Width           =   855
      End
      Begin VB.CheckBox Check3 
         Caption         =   "Filled"
         Height          =   255
         Left            =   120
         TabIndex        =   3
         Top             =   960
         Width           =   975
      End
      Begin VB.CheckBox Check1 
         Caption         =   "Rnd Colour"
         Height          =   255
         Left            =   120
         TabIndex        =   2
         Top             =   480
         Width           =   1095
      End
      Begin VB.CheckBox Check2 
         Caption         =   "Square"
         Height          =   255
         Left            =   120
         TabIndex        =   1
         Top             =   720
         Width           =   855
      End
      Begin VB.Label Label2 
         Height          =   255
         Left            =   1005
         TabIndex        =   5
         ToolTipText     =   "timer interval"
         Top             =   1200
         Width           =   375
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'draw squares(rectangles) that don't overlap
'doesn't test if square is on form
'note: it takes longer to calculate the more squares are drawn
'Rethink of algorithm:
'Pseudo Random Squares/Rectangles
'Doesn't use Win API functions
'version 3
'added -filled checkbox
'Rethink -
'use precalculated squares - rndly put squares in areas
'assumes 800*600 window/screen
'
Option Explicit
Dim sq1 As cSquare
Dim list As New Collection


Private Sub cmdDrawSquares_Click()

    drawsquares

End Sub

Private Sub cmdtimer1_Click()

    Timer1.Enabled = Not Timer1.Enabled

    If Timer1.Enabled = False Then

        cmdtimer1.Caption = "timer=off"

    Else

        cmdtimer1.Caption = "timer=on"

    End If

End Sub

Private Sub Form_Load()
    
    'user class cSquare because user defined type has limitations
    'start random seed for better random sequence
    Randomize
    'initialise label
    HScroll2_Change

End Sub

Private Sub Form_Unload(Cancel As Integer)

    Dim vcounter As Variant
    'delete each stored object

    For Each vcounter In list

        'MsgBox vcounter.x1
        Set vcounter = Nothing

    Next vcounter

    'delete collection
    Set list = Nothing

End Sub

Sub drawsquares()

    Dim xoffset As Long, yoffset As Long, clr, rnumber As Long
    Dim count As Long, vcount As Variant, outindex As Long, vcounter As Variant
    'For outindex = 0 To 3
    Cls

    For yoffset = 0 To 5

        For xoffset = 0 To 7

            ''clr = RGB(Int(Rnd * 256) + 1, Int(Rnd * 256) + 1, Int(Rnd * 256) + 1)
            'get rnd number between 0-7 (we have 8 predefined rectangles)
            '3 random squares(choosen from 8 possible)
            Dim strlist As String, jumpout As Boolean
            strlist = ""

            For count = 1 To 7

                '''rnumber = Int((Rnd * 8)) '0-7)
                'get unique sequence
    
                '''jumpout = False
                'if rnumber is in list

                Do While InStr(1, strlist, CStr(rnumber)) > 0

                    'get random number
                    rnumber = Int((Rnd * 8)) '0-7)

                Loop

                'put item in list
                strlist = strlist & CStr(rnumber)
                Set sq1 = New cSquare
    
                assignPreSquare rnumber, xoffset * 100, yoffset * 100
                'MsgBox sq1.x1
                list.Add sq1

            Next count

            ''MsgBox "the string list = " & strlist
            ''Form1.Line (0 + (xoffset * 100), 0 + (yoffset * 100))-(99 + (xoffset * 100), 99 + (yoffset * 100)), clr, BF

        Next xoffset

    Next yoffset
    'draw objects on form
    drawlist
    
    'delete listitems
    For Each vcounter In list

        Set vcounter = Nothing

    Next vcounter

    Dim itemcount As Long
    'removeitems from collection
    'collection is 1 based;1-10 = 10,9,8,7,6,5,4,3,2,1
    For itemcount = list.count To 1 Step -1

        list.Remove itemcount

    Next

End Sub

'precalculate objects in one area
'offset to 48 (8*6) diff areas
'x,y
'0,0     '25,0     '76,0      '
'   24,24'    75,24'    99,49 '
'        '         '          '
'        '         '          '
'        '         '          '
'        '         '          '
Sub assignPreSquare(index As Long, xoffset As Long, yoffset As Long)

    Select Case index

        Case 0
            '
            sq1.assigncoords 0, 0, 24, 24, xoffset, yoffset
            '
'            sq1.x1 = 0 + xoffset
'            sq1.y1 = 0 + yoffset
'            sq1.x2 = 24 + xoffset
'            sq1.y2 = 24 + yoffset

        Case 1
            sq1.assigncoords 25, 0, 75, 24, xoffset, yoffset
'            sq1.x1 = 25 + xoffset
'            sq1.y1 = 0 + yoffset
'            sq1.x2 = 75 + xoffset
'            sq1.y2 = 24 + yoffset

        Case 2
            sq1.assigncoords 76, 0, 99, 49, xoffset, yoffset
'            sq1.x1 = 76 + xoffset
'            sq1.y1 = 0 + yoffset
'            sq1.x2 = 99 + xoffset
'            sq1.y2 = 49 + yoffset

        Case 3
            sq1.assigncoords 0, 25, 24, 75, xoffset, yoffset
'            sq1.x1 = 0 + xoffset
'            sq1.y1 = 25 + yoffset
'            sq1.x2 = 24 + xoffset
'            sq1.y2 = 75 + yoffset

        Case 4
            sq1.assigncoords 25, 25, 75, 75, xoffset, yoffset
'            sq1.x1 = 25 + xoffset
'            sq1.y1 = 25 + yoffset
'            sq1.x2 = 75 + xoffset
'            sq1.y2 = 75 + yoffset

        Case 5
            sq1.assigncoords 76, 50, 99, 99, xoffset, yoffset
'            sq1.x1 = 76 + xoffset
'            sq1.y1 = 50 + yoffset
'            sq1.x2 = 99 + xoffset
'            sq1.y2 = 99 + yoffset

        Case 6
            sq1.assigncoords 0, 76, 49, 99, xoffset, yoffset
'            sq1.x1 = 0 + xoffset
'            sq1.y1 = 76 + yoffset
'            sq1.x2 = 49 + xoffset
'            sq1.y2 = 99 + yoffset

        Case 7
            sq1.assigncoords 50, 76, 75, 99, xoffset, yoffset
'            sq1.x1 = 50 + xoffset
'            sq1.y1 = 76 + yoffset
'            sq1.x2 = 75 + xoffset
'            sq1.y2 = 99 + yoffset

    End Select

    Dim xwidth As Long, yheight As Long, widthToAdd As Long

    'constrain to sqr if need be
    xwidth = sq1.x2 - sq1.x1
    yheight = sq1.y2 - sq1.y1

    If xwidth > yheight Then

        widthToAdd = yheight

    Else

        widthToAdd = xwidth

    End If

    'if square checkbox selected

    If Check2.Value Then

        sq1.x2 = sq1.x1 + widthToAdd
        sq1.y2 = sq1.y1 + widthToAdd

    End If

    'MsgBox sq1.x1
    Dim r As Long, oldWidth As Long, oldHeight As Long, newWidth As Long, newHeight As Long
    'reduce width of object randomly
    Dim newx1 As Long, newy1 As Long
    r = Int(Rnd * 6) '0-5
    oldWidth = (sq1.x2 - sq1.x1)
    oldHeight = (sq1.y2 - sq1.y1)
    'reduces width/height of object
    'select which amount to divide by

    Select Case r

        Case 1
            sq1.x2 = sq1.x1 + oldWidth / 2
            sq1.y2 = sq1.y1 + oldHeight / 2

        Case 2
            sq1.x2 = sq1.x1 + oldWidth \ 3
            sq1.y2 = sq1.y1 + oldHeight \ 3

        Case 3
            sq1.x2 = sq1.x1 + oldWidth \ 4
            sq1.y2 = sq1.y1 + oldHeight \ 4

        Case 4
            sq1.x2 = sq1.x1 + oldWidth \ 6
            sq1.y2 = sq1.y1 + oldHeight \ 6

        Case 5 ' objects have minimum 25 width- so 25/12=
            sq1.x2 = sq1.x1 + oldWidth \ 12
            sq1.y2 = sq1.y1 + oldHeight \ 12

    End Select
    'jiggle the reduced objects
    If r <> 0 Then

        newWidth = (sq1.x2 - sq1.x1)
        newHeight = (sq1.y2 - sq1.y1)
        ''randomly place the start of the rectangle
        Dim jigglex As Long, jiggley As Long
        jigglex = Int(Rnd * (oldWidth - newWidth) + 1)
        jiggley = Int(Rnd * (oldHeight - newHeight))
        sq1.x1 = sq1.x1 + jigglex
        sq1.x2 = sq1.x2 + jigglex
        'move bottom right of object as well
        sq1.y1 = sq1.y1 + jiggley
        sq1.y2 = sq1.y2 + jiggley

    End If

    'sq1.x1 = sq1.x1 + Int(Rnd * 20)

End Sub

Sub drawlist()

    Dim vcounter As Variant
    Dim clr

    For Each vcounter In list

        If Check1.Value Then

            clr = RGB(Int(Rnd * 256) + 1, Int(Rnd * 256) + 1, Int(Rnd * 256) + 1)

        Else

            clr = &H0&

        End If

        If Check3.Value Then

            Form1.Line (vcounter.x1, vcounter.y1)-(vcounter.x2, vcounter.y2), clr, BF

        Else

            Form1.Line (vcounter.x1, vcounter.y1)-(vcounter.x2, vcounter.y2), clr, B

        End If

    Next vcounter

End Sub

Private Sub HScroll2_Change()

    Label2.Caption = HScroll2.Value

End Sub

Private Sub Timer1_Timer()

    Timer1.Interval = HScroll2.Value
    'cause the sub to execute via the command button
    cmdDrawSquares.Value = True

End Sub

